%define sover 4
Name: lua%sover
Version: 4.0.1
Release: alt7

Summary: Lua is a powerful, light-weight programming language
License: BSD-like
Group: Development/Other

Url: http://www.lua.org
# http://www.lua.org/ftp/
Source: lua-%version.tar.bz2

# under alternatives control
%set_compress_method gzip
Conflicts: lua5 < 5.0-alt5

PreReq: alternatives >= 0.0.6
Requires: lib%name = %version-%release
Provides:  lua = %version
Obsoletes: lua

# Automatically added by buildreq on Sun Aug 24 2003
BuildRequires: libalternatives-devel

%package -n lib%name
Summary: Lua programming language, shared libraries
Group: Development/Other
License: BSD-like

%package -n lib%name-devel
Summary: Lua programming language, header files
Group: Development/Other
License: BSD-like
Requires: lib%name = %version-%release
Provides: lua-devel = %version, liblua-devel = %version
Obsoletes: lua-devel, liblua-devel

%package -n lib%name-devel-static
Summary: Lua programming language, static libraries
Group: Development/Other
License: BSD-like
Requires: lib%name-devel = %version-%release
Provides: lua-devel-static = %version, liblua-devel-static = %version
Obsoletes: lua-devel-static, liblua-devel-static

%description
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains lua compiler and interpreter, as well as code samples
and reference manual of the language.

%description -n lib%name
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains lua runtime shared libraries.

%description -n lib%name-devel
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains header files needed to embed Lua in C/C++ programs.

%description -n lib%name-devel-static
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains static libraries one may need to embed lua statically.

%prep
%setup -q -n lua-%version

%build
: custom build
DEST=$PWD/ready
%__mkdir_p $DEST

# tweak stdio.h with -D_GNU_SOURCE to get popen(3) and pclose(3) prototypes
CFLAGS="-I$PWD/include -I$PWD/src -D_POSIX_SOURCE=1 -D_GNU_SOURCE=1 -DPOPEN=1"

: static libraries
cd ./src
gcc $CFLAGS %optflags -c *.c
ar rcu $DEST/liblua.a *.o
ranlib $DEST/liblua.a

cd ./lib
gcc $CFLAGS %optflags -c *.c
ar rcu $DEST/liblualib.a *.o
ranlib $DEST/liblualib.a

: dynamic libraries
cd ..
gcc $CFLAGS %optflags %optflags_shared -c *.c
ld -o $DEST/liblua.so.%sover -soname=liblua.so.%sover -shared -O1 -lc *.o
ln -s liblua.so.%sover $DEST/liblua.so

cd ./lib
gcc $CFLAGS %optflags %optflags_shared -c *.c
ld -o $DEST/liblualib.so.%sover -soname=liblualib.so.%sover -shared -O1 -lc -lm -ldl *.o
ln -s liblualib.so.%sover $DEST/liblualib.so

: executables
cd ../lua
gcc $CFLAGS %optflags *.c -o $DEST/lua -L$DEST -llua -llualib
cd ../luac 
gcc $CFLAGS %optflags *.c -o $DEST/luac -L$DEST -llua

%install
%__mkdir_p %buildroot{%_bindir,%_libdir,%_includedir,%_man1dir,%_altdir,%_datadir/%name/{etc,test}}
%__cp -a ready/*.a ready/*.so* %buildroot%_libdir/
%__cp -a include/*.h %buildroot%_includedir/
%__install -p -m644 test/*.lua test/README \
	%buildroot%_datadir/%name/test/
%__install -p -m644 etc/*.* etc/README \
	%buildroot%_datadir/%name/etc/
# alternatives
%__cp -a ready/lua %buildroot%_bindir/lua%sover
%__cp -a ready/luac %buildroot%_bindir/luac%sover
%__cp -a doc/lua.1 %buildroot%_man1dir/lua%sover.1
%__cp -a doc/luac.1 %buildroot%_man1dir/luac%sover.1

cat <<EOF >%buildroot%_altdir/%name
<group name="candidate">
	<option name="link">%_bindir/lua</option>
	<option name="real">%_bindir/lua%sover</option>
	<option name="weight" type="number">10</option>
	<group name="slave">
		<option name="link">%_bindir/luac.1.gz</option>
		<option name="real">%_bindir/luac%sover.1.gz</option>
	</group>
	<group name="slave">
		<option name="link">%_man1dir/lua.1.gz</option>
		<option name="real">%_man1dir/lua%sover.1.gz</option>
	</group>
	<group name="slave">
		<option name="link">%_man1dir/luac.1.gz</option>
		<option name="real">%_man1dir/luac%sover.1.gz</option>
	</group>
</group>
EOF

%post
%register_alternatives %name

%preun
%unregister_alternatives %name

%define _customdocdir %_docdir/lua-%version

%files
%_altdir/*
%_bindir/lua*
%_man1dir/*
%_datadir/%name
%doc doc/*.html doc/*.gif

%files -n lib%name
%_libdir/*.so.*
%doc COPYRIGHT HISTORY README*

%files -n lib%name-devel
%_libdir/*.so
%_includedir/*.h

%files -n lib%name-devel-static
%_libdir/*.a

%post -n lib%name
%post_ldconfig

%postun -n lib%name
%postun_ldconfig

%changelog
* Sun Aug 24 2003 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt7
- moved lua4 (weight=10) and lua5 (weight=20) packages under alternatives control

* Fri Jun 20 2003 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt6
- new package layout: lua4, liblua4, liblua4-devel, liblua4-devel-static
- abandon makefiles, custom build with direct commands
- removed loadlib stuff (lua5 feature)
- popen feature enabled
- soname changed: liblua.so.4.0 -> liblua.so.4

* Thu Dec 26 2002 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt5
- corrected s/-lc/-lc -lm -ldl/ for liblualib.so in alt-soname patch
- shared optimization flags

* Tue Dec 24 2002 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt4
- error in previous build: *.so files are binary copy of *.so.* files,
  not symlinks; fixed
- really shared build (s/ld -shared/ld -shared -lc/ in alt-soname patch)
- post and postun sections added (ldconfig)

* Fri Dec 20 2002 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt3
- shared build; alt-soname patch; lua-devel-static subpackage
- reference manual and code samples included in lua-devel package
- additional features from XTG Systems (loadlib files) and
  PLD Team (pld-loadlib-require patch)
- buildreq applied (none)

* Mon Oct 28 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.1-alt2
- Rebuilt in new environment

* Wed Aug 28 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.1-alt1
- First build for Sisyphus
